// Arctan.java                                      MM 2013

/**
 * Logarithmusfunktion f(x) = arctan( x),
 * D = R, W = ] -PI/2, PI/2[.
 */
public class Arctan extends DifferenzierbareFunktion
{
/* ----------------------------------------------------- */
                                         // service-Methode
/**
 * Berechnen eines Funktionswertes.
 * @param arg Argument
 * @return arctan( arg)
 */
  public double wert( double arg)
  {
// Trivialfall
    if( arg == 0) return 0;

// einfache Newtoniteration
//  return myArctan( arg);
// verbesserte Newtoniteration
    return myArctanBesser( arg);
  }

/**
 * Berechnen eines Funktionswertes als Nullstelle der
 * Umkehrfunktion tan( x) - arg mittels Newton.
 * @param arg Argument
 * @return arctan( arg)
 */
  private double myArctan( double arg)
  {
// Newtoniteration  (b)




  }

/**
 * Verbesserte Funktionswertberechnung fuer |x| > 1.
 * @param arg Argument
 * @return arctan( arg)
 */
  private double myArctanBesser( double arg)
  {
// Verbesserung  (c)




  }


/**
 * Berechnen einer ersten Ableitung
 * f'(x) = 1 / ( 1 + x^2).
 * @param arg Argument
 * @return f'( arg)
 */
  public double wertErsteAbleitung( double arg)
  {
// Trivialfall
    if( arg == 0) return 0;

// Sonst
    return 1 / ( 1 + arg * arg);
  }

/* ----------------------------------------------------- */
                                        // toString-Methode
/**
 * Darstellen der Arcustangensfunktion.
 * @return Funktion in linearer Schreibweise
 */
  public String toString()
  {
    return "arctan( x)";
  }
}